rem as_backup: This script connects to the local asset server and dumps the
rem entire project in a way usable by as_restore
@echo off

rem Assume we are executing from the asset server bin directory or try default path
set PREFIX=%CD%\..
if not exist "%PREFIX%\bin\psql.exe" set PREFIX=%PROGRAMFILES(x86)%\Unity\AssetServer
if not exist "%PREFIX%\bin\psql.exe" set PREFIX=%PROGRAMFILES%\Unity\AssetServer

if not exist "%PREFIX%" echo Asset server not found in %PREFIX% & goto exit

set PGDATA="%PREFIX%\data"

rem Backup directory
set BACKUP=%1
if x%1==x set BACKUP="%PREFIX%\dump"

rem Tools
set DUMPALL="%PREFIX%\bin\pg_dumpall"
set DUMP="%PREFIX%\bin\pg_dump"
set PSQL="%PREFIX%\bin\psql"
set SPLIT="%PREFIX%\bin\split"

rem Make sure backup directory is created and empty
rem move any old backup dir to the side
for /f "tokens=1,2,3,4 delims=:," %%A in ("%TIME%") do set TIMESTAMP=%%A%%B%%C
if exist %BACKUP% move %BACKUP% %BACKUP%_%DATE%-%TIMESTAMP%

mkdir %BACKUP%
if errorlevel 1 echo Failed to create %BACKUP%. Do you have administrative privileges? & goto exit
pushd %BACKUP%

echo Fetching list of projects
%PSQL% -U unitysrv -p 10733 -d postgres -c "select databasename || ':' || projectname || ':' || description || ':'  || version from all_databases__view order by databasename" -A -t > 00_projects.txt

echo Dumping users and global objects
%DUMPALL% -U unitysrv -p 10733  -g > 10_global_data.sql

rem Finally dump all data for each project, splitting the output into 1GB size chunks
for /f "delims=:" %%X in ('type 00_projects.txt') do echo Dumping %%X & %DUMP% -U unitysrv -p 10733 -F c -a -b -o -Z0 -T configuration__matview --disable-triggers %%X | %SPLIT% -a 4 -b 1000m - 90_%%X.
popd

echo ===== Done

:exit
pause
