rem as_restore: This script connects to the local asset server and restores all
rem projects from the backup. A requirement is that the projects do not exist 
rem on the server beforehand.@echo off
@echo off

rem Assume we are executing from the asset server bin directory or try default path
set PREFIX=%CD%\..
if not exist "%PREFIX%\bin\psql.exe" set PREFIX=%PROGRAMFILES(x86)%\Unity\AssetServer
if not exist "%PREFIX%\bin\psql.exe" set PREFIX=%PROGRAMFILES%\Unity\AssetServer

if not exist "%PREFIX%" echo Asset server not found in %PREFIX% & goto exit

set PGDATA="%PREFIX%\data"

rem Backup directory
set BACKUP=%1
if x%1==x set BACKUP="%PREFIX%\dump"

rem Tools
set RESTORE="%PREFIX%\bin\pg_restore"
set PSQL="%PREFIX%\bin\psql"
set CREATEDB="%PREFIX%\bin\createdb"
set DROPDB="%PREFIX%\bin\dropdb"

pushd %BACKUP%
if errorlevel 1 echo Failed to change directory to %BACKUP%. Do you have your backup directory ready? & goto exit

if not exist 00_projects.txt echo %BACKUP% is not a valid backup directory & goto exit
if not exist 10_global_data.sql echo %BACKUP% is not a valid backup directory & goto exit

echo ===== Restoring users and global objects
%PSQL% -U unitysrv -p 10733 -d postgres < 10_global_data.sql 

for /f "tokens=1,2,3,4 delims=:" %%A in ('type 00_projects.txt') do call :processproject %%A "%%B" "%%C" %%D
popd
goto done

:processproject
echo ===== Restoring db:%1 proj:%2 desc:%3 ver:%4
rem Get rid of quotes
for /f "useback tokens=*" %%X in ('%2') do set PROJ=%%~X
for /f "useback tokens=*" %%X in ('%3') do set DESC=%%~X
%CREATEDB% -U unitysrv -p 10733 %1
if errorlevel 1 echo ===== Database %1 already exists, skipping project %PROJ% & goto :EOF
%PSQL% -U unitysrv -p 10733 -d %1 -c "truncate table asset, assetversion, assetcontents, assettype, changeset, changesetcontents, person, personroles, reinheritance, role, stream, variant, variantcontents, variantinheritance;"
type 90_%1.* | %RESTORE% -U unitysrv -p 10733 -F c -d %1 -a --disable-triggers
if errorlevel 1 call :dropdatabase %1 & goto :EOF
%PSQL% -U unitysrv -p 10733 -d %1 -c "select set_project_info('%1','%PROJ%','%DESC%');" 
%PSQL% -U unitysrv -p 10733 -d %1 -c "select fix_user_privileges()"
goto :EOF

:dropdatabase
echo WARNING: Could not restore project %PROJ%
%DROPDB% -U unitysrv -p 10733 %1
if errorlevel 1 echo Could not clean up failed database %1. Please delete this database manually before attempting another restore
goto :EOF

:done
echo ===== Done

:exit
pause
